{
                 ===================================
                 www.geocities.com/iniwebsiteku
                 www.geocities.com/adi_nugroho_citra
                 ===================================

               /=====================================\
         --==< Drawing Math Functions sin(x) ; cos(x) >==--
               \=====================================/
english
=======                   
     purpose     : to draw math functions using TChart ; especially sin(x) and cos(x)
     notes       : <> it's a simple, easy and fast way
                      to draw any "simple" math functions
                      using TChart's component,
                      we don't need a "conventional way" using PIXEL !!!

                   <> you could save it as bitmap file (BMP file)

indonesia
=========
     tujuan:     untuk menggambar fungsi matematika sederhana; terutama sin(x) dan cos(x)
                 dengan menggunakan komponen TChart

     keterangan: <> menggambar fungsi matematika dengan menggunakan
                       komponen TChart ternyata sangat mudah dan cepat
                       apabila dibandingkan dengan menggunakan
                       metode menggambar yang "konvensional" piksel per piksel
                       yang sangat lama dan rumit

                 <> grafik matematika yang dibuat dapat disimpan sebagai file bitmap
                 
     dibuat oleh:
           ADI NUGROHO
           Jurusan Fisika
           FMIPA - Universitas Gadjah Mada       
           Yogyakarta
           INDONESIA
           
     tanggal : 26 Agustus 2002
}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls,

  Math,
  ShellAPI,
  ComCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    StatusBar1: TStatusBar;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Button3: TButton;
    SavePictureDialog1: TSavePictureDialog;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox4: TGroupBox;
    Edit4: TEdit;
    Edit5: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
     x,y: double;                  // y = f(x)
     X_Min, X_Max : double;        // variable for x_min and x_max
     Y_Min, Y_Max : double;        // variable for y_min and y_max
     IntervalX : double;           // variable for dx

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
// salah satu trik untuk menampilkan kotak about secara cepat,
// tanpa harus membuat form

// trick to make aN AboutBox, we don't need a form !!!
     ShellAbout (Handle, 'Draw Sin(x) and Cos(x) using TChart',
           '     Adi Nugroho' + #13#10 +
           '     www.geocities.com/iniwebsiteku/ ',
           Application.Icon.Handle);
end;

// 2*PI = 6.28
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
     case ComboBox1.ItemIndex of
     0 : // fungsi sinus , y = sin(x)
           begin
                 // input for drawing area
                 X_Min := StrToFloat (Edit1.Text);
                 X_Max := StrToFloat (Edit2.Text);

                 Y_Min := StrToFloat (Edit4.Text);
                 Y_Max := StrToFloat (Edit5.Text);
                 
                 IntervalX := StrToFloat (Edit3.Text);
                 // note for IntervalX ::
                 //    you will have a smoother graphics if you set IntervalX small enough
                 //    but the process will take more time  !!!

                 // kalau kamu mengisikan IntervalX dengan nilai yang sangat kecil,
                 // maka kamu akan memperoleh tampilan grafik yang halus
                 // tetapi hal ini akan memakan waktu/memerlukan proses yang lebih lama

                 // Axis.Automatic must be set to FALSE !
                 // double click on TChart component, go to tab Axis | Scale and uncheck the Automatic
                 // or AutoSize' properties FALSE...
                 //
                 // these are the boundary of drawing area
                 Chart1.BottomAxis.Minimum     := X_Min;
                 Chart1.BottomAxis.Maximum     := X_Max;
                 Chart1.LeftAxis.Minimum       := Y_Min;
                 Chart1.LeftAxis.Maximum       := Y_Max;

                 Series1.Clear;
                 Chart1.Title.Text.Text := 'Sin(x)';

                 // from left ...
                 x := Chart1.BottomAxis.Minimum;
                 repeat                       
                       begin
                             // this is the math function
                             y := sin (x);

                             // make sure that graph is in Chart area  (drawing area)
                             if (y <= Chart1.LeftAxis.Maximum) and
                                (y >= Chart1.LeftAxis.Minimum) then
                             begin
                                   // draw the function !!!
                                   Series1.AddXY (x,y,'',clRed);                                   
                             end;
                             x := x + IntervalX;
                             // or you could write ::--> x := x + 0.1;
                       end;
                 // ... to right
                 until x >= Chart1.BottomAxis.Maximum;
           end;

     1 : // fungsi cosinus  , y = cos(x)
           begin
                 X_Min := StrToFloat (Edit1.Text);
                 X_Max := StrToFloat (Edit2.Text);      

                 Y_Min := StrToFloat (Edit4.Text);
                 Y_Max := StrToFloat (Edit5.Text);        

                 IntervalX := StrToFloat (Edit3.Text);

                 Chart1.BottomAxis.Minimum     := X_Min;
                 Chart1.BottomAxis.Maximum     := X_Max;
                 Chart1.LeftAxis.Minimum       := Y_Min;
                 Chart1.LeftAxis.Maximum       := Y_Max;

                 Series1.Clear;
                 Chart1.Title.Text.Text := 'Cos(x)';

                 x := Chart1.BottomAxis.Minimum;
                 repeat                       
                       begin
                             y := cos (x);

                             if (y <= Chart1.LeftAxis.Maximum) and
                                (y >= Chart1.LeftAxis.Minimum) then
                             begin
                                   Series1.AddXY (x,y,'',clRed);                                   
                             end;
                             x := x + IntervalX;
                             
                       end;
                 until x >= Chart1.BottomAxis.Maximum;
           end;

     2 : // fungsi 2 * sin(5*x) - sin(4*x)
           begin
                 X_Min := StrToFloat (Edit1.Text);       
                 X_Max := StrToFloat (Edit2.Text);       

                 Y_Min := StrToFloat (Edit4.Text);       
                 Y_Max := StrToFloat (Edit5.Text);       

                 IntervalX := StrToFloat (Edit3.Text);

                 Chart1.BottomAxis.Minimum     := X_Min;
                 Chart1.BottomAxis.Maximum     := X_Max;
                 Chart1.LeftAxis.Minimum       := Y_Min;
                 Chart1.LeftAxis.Maximum       := Y_Max;

                 Series1.Clear;
                 Chart1.Title.Text.Text := '2 * Sin(5x) - Sin(4x)';

                 x := Chart1.BottomAxis.Minimum;
                 repeat                       
                       begin
                             y := 2 * sin(5*x) - sin(4*x);

                             if (y <= Chart1.LeftAxis.Maximum) and
                                (y >= Chart1.LeftAxis.Minimum) then
                             begin
                                   Series1.AddXY (x,y,'',clRed);                                   
                             end;
                             x := x + IntervalX;

                       end;
                 until x >= Chart1.BottomAxis.Maximum;
           end;
                        
     3 : // fungsi cos(3*x) + 2 * cos(4*x)
           begin
                 X_Min := StrToFloat (Edit1.Text);
                 X_Max := StrToFloat (Edit2.Text);

                 Y_Min := StrToFloat (Edit4.Text);
                 Y_Max := StrToFloat (Edit5.Text);

                 IntervalX := StrToFloat (Edit3.Text);

                 Chart1.BottomAxis.Minimum     := X_Min;
                 Chart1.BottomAxis.Maximum     := X_Max;
                 Chart1.LeftAxis.Minimum       := Y_Min;
                 Chart1.LeftAxis.Maximum       := Y_Max;

                 Series1.Clear;
                 Chart1.Title.Text.Text := 'Cos(3*x) + 2 * Cos(4*x)';

                 x := Chart1.BottomAxis.Minimum;
                 repeat                       
                       begin
                             y := cos(3*x) + 2 * cos(4*x);

                             if (y <= Chart1.LeftAxis.Maximum) and
                                (y >= Chart1.LeftAxis.Minimum) then
                             begin
                                   Series1.AddXY (x,y,'',clRed);                                   
                             end;
                             x := x + IntervalX;

                       end;
                 until x >= Chart1.BottomAxis.Maximum;
           end;

     4 : // fungsi 2*cos(2*x) - sin(5*x)
           begin
                 X_Min := StrToFloat (Edit1.Text);
                 X_Max := StrToFloat (Edit2.Text);

                 Y_Min := StrToFloat (Edit4.Text);
                 Y_Max := StrToFloat (Edit5.Text);       

                 IntervalX := StrToFloat (Edit3.Text);

                 Chart1.BottomAxis.Minimum     := X_Min;
                 Chart1.BottomAxis.Maximum     := X_Max;
                 Chart1.LeftAxis.Minimum       := Y_Min;
                 Chart1.LeftAxis.Maximum       := Y_Max;

                 Series1.Clear;
                 Chart1.Title.Text.Text := '2 * Cos(2*x) - Sin(5*x)';

                 x := Chart1.BottomAxis.Minimum;
                 repeat                       
                       begin
                             y := 2*cos(2*x) - sin(5*x) ;

                             if (y <= Chart1.LeftAxis.Maximum) and
                                (y >= Chart1.LeftAxis.Minimum) then
                             begin
                                   Series1.AddXY (x,y,'',clRed);                                   
                             end;
                             x := x + IntervalX;

                       end;
                 until x >= Chart1.BottomAxis.Maximum;
           end;


{
     5 : // function: TANGENT
     
           // Notes from me :      f(?.?)       (*_*)      (?_?)      (+_+)
           // =============
           // i dont have any idea why this function cannot be draw correctly,
           // tangent(x) = sin(x) / cos(x)
           // when cos(x) = 0, so tangent(x) = sin(x) / 0, --> DIVISION BY zero !!
           // i try not to draw that condition, ....
           //     i use this code to "jump"
           //     -->  if cos(x) <> 0 then y := sin(x) / cos(x);
           // ... but using TChart it still be drawn
           //
           //
           // when u draw this using Canvas, it should be work, but using TChart
           // u will got a "weird" result
           //
           // IF YOU HAVE A SOLUTION TO DRAW THESE FUNCTIONS : TANGENT, COTANGENT, SECANT, COSECANT
           // PLEASE CONTACT ME ...    (using TChart... of course)
           // I NEED IT
           //     thx ...
                 
           begin
                 X_Min := StrToFloat (Edit1.Text);      
                 X_Max := StrToFloat (Edit2.Text);      

                 Y_Min := StrToFloat (Edit4.Text);      
                 Y_Max := StrToFloat (Edit5.Text);      

                 IntervalX := StrToFloat (Edit3.Text);

                 Chart1.BottomAxis.Minimum     := X_Min;
                 Chart1.BottomAxis.Maximum     := X_Max;
                 Chart1.LeftAxis.Minimum       := Y_Min;
                 Chart1.LeftAxis.Maximum       := Y_Max;

                 Series1.Clear;
                 Chart1.Title.Text.Text := 'Tan (x)';

                 x := Chart1.BottomAxis.Minimum;
                 repeat                       
                       begin

                             if cos(x) <> 0 then y := sin(x) / cos(x);

                             if (y <= Chart1.LeftAxis.Maximum) and
                                (y >= Chart1.LeftAxis.Minimum) then
                             begin
                                   Series1.AddXY (x,y,'',clRed);                                   
                             end;
                             x := x + IntervalX;
                             // or you could write ::--> x := x + 0.1;
                       end;
                 until x >= Chart1.BottomAxis.Maximum;
           end;
           }
     end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
// fuih... i want out !       (^.^;)
     Application.Terminate;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
// you could save your graphics as bitmap file (BMP)
     if SavePictureDialog1.Execute then
     begin
           Chart1.SaveToBitmapFile (SavePictureDialog1.FileName);
     end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
// it's just a note
     label4.Caption := 'smaller dx, smoother graphics' + #13#10 +
                       'slower process !!!';

end;

end.
